{pgmail.pas}

{email code originally for for bserv}

{ Copyright (C) 2005 Bas Steendijk and Peter Green
  For conditions of distribution and use, see copyright notice in zlib_license.txt
  which is included in the package
  ----------------------------------------------------------------------------- }

// note freepascal has a nasty tendency to munge the object reference part
// of method pointer routines so this code stores the object references
// seperately in the tsockets tag

// further note if you wan't a line in the e-mail to start with a full stop
// you must start it with 2 full stops. read RFC821 on smtp for more details

unit pgmail;

interface
  uses
    {$ifdef win32}
      windows,
      wsocket,
    {$else}
      //linux,
      lsocket,
    {$endif}
    classes ,sysutils, pgdebugout;

  type


    tmailreturnproc = procedure(reply : string) of object;
    tmailobject = class(tobject)
    protected
      fromaddr   : string;
      fromrealname:string;
      toaddr     : string;
      body       : string;
      //mailserver : string;
      subject    : string;
      stage      : integer;
      returnproc : tmailreturnproc;

      {$ifdef win32}
        sock : twsocket;
      {$else}
        sock : tlsocket;
      {$endif}
      procedure connected(sender:tobject; error:word);
      procedure closed(sender:tobject; error:word);
      procedure receive(sender:tobject; error:word);


    public
      reply      : string;
      //finished   : boolean;


    end;
  //procedure timehandler;
  procedure sendmail(fromaddr,fromrealname, toaddr, body,mailserver,subject : string;returnproc : tmailreturnproc);

  // this does a case insensitive compare due to the fact it is designed to
  // be used in abuse checking
  function compareemail(a,b : string; compareserveronly : boolean) : boolean;

  {procedure init;            }
  {var

    mailobjects : tlist; }
implementation

// this does a case insensitive compare due to the fact it is designed to
// be used in abuse checking
function compareemail(a,b : string; compareserveronly : boolean) : boolean;
begin
  if compareserveronly then begin
    a:= copy(a,pos('@',a)+1,32767);
    b:= copy(a,pos('@',a)+1,32767);

  end;
  result := (uppercase(a)=uppercase(b));//strcompup(a,b);
end;


type
  {$ifdef win32}
    tsocket=twsocket;
  {$else}
    tsocket=tlsocket;
  {$endif}
{procedure timehandler;
var
  counter : integer;
begin
  debugout(mailobjects.count);
  if mailobjects.count > 0 then for counter :=  mailobjects.count -1 downto 0 do  try

    if tmailobject(mailobjects[counter]).finished then begin
      if tmailobject(mailobjects[counter])=nil then debugout('nil detected') else begin;

        tmailobject(mailobjects[counter]).returnproc(tmailobject(mailobjects[counter]).reply);
        tmailobject(mailobjects[counter]).free;
        mailobjects[counter] := nil;
        mailobjects.Delete(counter);
      end;
    end;
  except
    debugout('exception raised in pgmail.timehandler'+exceptobject.classname+' '+(exceptobject as exception).message);
  end;
end; }

procedure sendmail(fromaddr,fromrealname,toaddr, body,mailserver,subject : string;returnproc : tmailreturnproc);
var
  mailobject : tmailobject;
  mailserveraddr : string;
  mailserverport : string;
  colonfound     : boolean;
  counter : word;
begin


  //now create the object which will handle sending of the mail
  //set stuff up and connect to the mailserver
  mailobject                 := tmailobject.create;
  //mailobject.finished        := false; //just in case
  mailobject.fromaddr        := fromaddr;
  mailobject.fromrealname    := fromrealname;
  mailobject.toaddr          := toaddr;
  mailobject.body            := body;
  //mailobject.mailserver      := mailserver;
  mailobject.subject         := subject;
  mailobject.returnproc      := returnproc;
  mailobject.reply           := 'nothing recieved yet';
  //debugout('thread should start after this');
  //ilthread.resume;

  {mailobjects.Add(mailobject);   }
  with mailobject do try
    sock := tsocket.create(nil);
    sock.onsessionconnected := connected;
    sock.ondataavailable := receive;
    sock.onsessionclosed := closed;
    sock.Tag := longint(mailobject);
    mailserveraddr := '';
    mailserverport := '';
    colonfound := false;
    for counter := 1 to length(mailserver) do begin
      if mailserver[counter] = ':' then begin
        colonfound := true
      end else begin;
        if colonfound then begin
          mailserverport := mailserverport + mailserver[counter];
        end else begin
          mailserveraddr := mailserveraddr + mailserver[counter];

        end;
      end;
    end;
    mailserverport := inttostr(strtointdef(mailserverport,25));

    sock.addr := mailserveraddr;
    sock.port := mailserverport;
    sock.proto := 'tcp';
    sock.connect;

  except
    on E: exception do begin
      mailobject.free;
      returnproc('exception raised dureing procedure sendmail type '+e.ClassName+' with message '+e.Message );
    end;
  end;
  if not assigned(mailobject.returnproc) then begin
  debugout('returnproc is not assigned');
    halt;
  end;
  debugout('longint(mailobject)='+inttohex(longint(mailobject),8));

end;

{procedure init;
begin
  mailobjects := tlist.create;
end;}


procedure tmailobject.connected(sender:tobject; error:word);
{$ifdef win32}
  var
    tempsock : tsocket;
{$endif}
begin
  with tmailobject(tsocket(sender).tag)  do begin
    debugout('tmailobject.connected called error='+inttostr(error));
    if error = 0 then begin
      stage := 0;

      sock.SendStr('helo bworld'+#13#10);
      debugout('socket connected');
    end else begin

      reply := 'connect failed';
      returnproc(reply);
      {$ifdef win32}
        sock := nil;      // this prevents my code from trying to free the sock
        tempsock := sock; // from an event handler that results from it being
        tempsock.free;        // freed

      {$else}
        sock.release;

      {$endif}
      free;

    end;
  end;
end;
procedure tmailobject.closed;
begin
  with tmailobject(tsocket(sender).tag)  do begin
    if assigned(sock) then begin // if sock is not assigned it means this is a
                                 // result of calling sock.free because of a
                                 // connect failure
      debugout('socket closed');
      debugout('longint(self)='+inttohex(longint(self),8));
      if not assigned(returnproc) then begin
        debugout('returnproc is not assigned');
        halt;
      end;


      debugout('about to call returnproc');
      returnproc(reply);
      debugout('returnproc finished');
      sock.release;


      free;
    end;
  end;
end;
procedure tmailobject.receive;
var
  data : string;
begin
  with tmailobject(tsocket(sender).tag)  do begin
    data := data + sock.receivestr;
    if (length(data) >0) and (data[length(data)] = #10) then begin
      reply := copy(data,1,length(data)-2);
      if (data[1] = '2') or (data[1] = '3') then begin
        case stage of
          0:begin
            sock.SendStr('mail from:<'+fromaddr+'>'+#13#10);
          end;
          1:begin
            sock.SendStr('rcpt to:<'+toaddr+'>'+#13#10);
          end;
          2:begin
            sock.SendStr('data'+#13#10);
          end;
          3:begin
            sock.SendStr('from: '+fromrealname+' <'+fromaddr+'>'+#13#10+
                         'to: <'+toaddr+'>'+#13#10+
                         'subject: '+subject+#13#10+
                         #13#10+
                         body+#13#10+
                         '.'+#13#10);
          end;
          4:begin
            sock.SendStr('quit'+#13#10);
          end;
        end;
        inc(stage);
      end else begin

        sock.close;

      end;
      data := '';
    end;
  end;
end;




end.
