(*
 *  beware IRC services, unixsignals.pas
 *  Copyright (C) 2002-2005 Bas Steendijk and Peter Green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)


unit unixsignals;

interface

procedure init;

implementation
uses
  {$ifdef VER1_0}
    linux,
  {$else}
    baseunix,unix,
  {$endif}
  lsignal,bconfig,bservicemngr,bservunit,bconsts,pgdebugout;
{$include unixstuff.inc}
var
  locallsignal : tlsignal;
type
  tsc=class
    procedure onsignal(sender:tobject;signal:integer);
  end;
var
  sc : tsc;

procedure init;
begin
  starthandlesignal(sigterm);
  starthandlesignal(sighup);
  locallsignal := tlsignal.create(nil);
  locallsignal.onsignal := sc.onsignal;

end;

procedure tsc.onsignal(sender:tobject;signal:integer);
var
  A : integer;
begin
  case signal of
    sigterm : begin
      debugout('sigterm received');
      globalshutdown;
    end;
    {sighup : begin
      debugout('sighup received');

      bconfig.init;

      for a := 0 to maxserviceunit do begin
        if serviceunitarray[a] <> nil then begin
          if @serviceunitarray[a].onrehash <> nil then begin
            serviceunitarray[a].onrehash(serviceunitarray[a].tag);
          end;
        end;
      end;
    end;}
  end;
end;
end.
